﻿/********************** 
 * Navon-Figures Test *
 **********************/


// store info about the experiment session:
let expName = 'navon-figures';  // from the Builder filename that created this script
let expInfo = {'participant': '', 'session': '001'};

// Start code blocks for 'Before Experiment'
// init psychoJS:
const psychoJS = new PsychoJS({
  debug: true
});

// open window:
psychoJS.openWindow({
  fullscr: true,
  color: new util.Color([0, 0, 0]),
  units: 'height',
  waitBlanking: true
});
// schedule the experiment:
psychoJS.schedule(psychoJS.gui.DlgFromDict({
  dictionary: expInfo,
  title: expName
}));

const flowScheduler = new Scheduler(psychoJS);
const dialogCancelScheduler = new Scheduler(psychoJS);
psychoJS.scheduleCondition(function() { return (psychoJS.gui.dialogComponent.button === 'OK'); }, flowScheduler, dialogCancelScheduler);

// flowScheduler gets run if the participants presses OK
flowScheduler.add(updateInfo); // add timeStamp
flowScheduler.add(experimentInit);
flowScheduler.add(setupRoutineBegin());
flowScheduler.add(setupRoutineEachFrame());
flowScheduler.add(setupRoutineEnd());
const trialsLoopScheduler = new Scheduler(psychoJS);
flowScheduler.add(trialsLoopBegin(trialsLoopScheduler));
flowScheduler.add(trialsLoopScheduler);
flowScheduler.add(trialsLoopEnd);
flowScheduler.add(endRoutineBegin());
flowScheduler.add(endRoutineEachFrame());
flowScheduler.add(endRoutineEnd());
flowScheduler.add(quitPsychoJS, '', true);

// quit if user presses Cancel in dialog box:
dialogCancelScheduler.add(quitPsychoJS, '', false);

psychoJS.start({
  expName: expName,
  expInfo: expInfo,
  resources: [
  ]
});

psychoJS.experimentLogger.setLevel(core.Logger.ServerLevel.EXP);


var frameDur;
async function updateInfo() {
  expInfo['date'] = util.MonotonicClock.getDateStr();  // add a simple timestamp
  expInfo['expName'] = expName;
  expInfo['psychopyVersion'] = '2021.2.3';
  expInfo['OS'] = window.navigator.platform;

  // store frame rate of monitor if we can measure it successfully
  expInfo['frameRate'] = psychoJS.window.getActualFrameRate();
  if (typeof expInfo['frameRate'] !== 'undefined')
    frameDur = 1.0 / Math.round(expInfo['frameRate']);
  else
    frameDur = 1.0 / 60.0; // couldn't get a reliable measure so guess

  // add info from the URL:
  util.addInfoFromUrl(expInfo);
  
  return Scheduler.Event.NEXT;
}


var setupClock;
var white;
var localHeight;
var localWidth;
var globalHeight;
var globalWidth;
var nY;
var letters;
var thisLetter;
var Idx;
var elements;
var nReps;
var fixClock;
var polygon;
var trialClock;
var key_resp;
var feedbackClock;
var text_thumb;
var endClock;
var text;
var globalClock;
var routineTimer;
async function experimentInit() {
  // Initialize components for Routine "setup"
  setupClock = new util.Clock();
  white = new util.Color([1, 1, 1]);
  
  localHeight = 0.02;
  localWidth = 0.015;
  globalHeight = 0.2;
  globalWidth = 0.15;
  nY = 9;
  localHeight = (globalHeight / nY);
  letters = [];
  thisLetter = ["e", "E"];
  for (var Idx, _pj_c = 0, _pj_a = util.range(nY), _pj_b = _pj_a.length; (_pj_c < _pj_b); _pj_c += 1) {
      Idx = _pj_a[_pj_c];
      thisLetter.push([((- globalWidth) / 2), (((Idx - (nY / 2)) / nY) * globalHeight)]);
  }
  for (var Idx, _pj_c = 0, _pj_a = util.range(1, nY), _pj_b = _pj_a.length; (_pj_c < _pj_b); _pj_c += 1) {
      Idx = _pj_a[_pj_c];
      thisLetter.push([((((0.5 + Idx) - (nY / 2)) / (nY - 1)) * globalWidth), ((globalHeight / 2) - localHeight)]);
  }
  for (var Idx, _pj_c = 0, _pj_a = util.range(1, (nY - 1)), _pj_b = _pj_a.length; (_pj_c < _pj_b); _pj_c += 1) {
      Idx = _pj_a[_pj_c];
      thisLetter.push([((((0.5 + Idx) - (nY / 2)) / (nY - 1)) * globalWidth), ((- localHeight) / 2)]);
  }
  for (var Idx, _pj_c = 0, _pj_a = util.range(1, nY), _pj_b = _pj_a.length; (_pj_c < _pj_b); _pj_c += 1) {
      Idx = _pj_a[_pj_c];
      thisLetter.push([((((0.5 + Idx) - (nY / 2)) / (nY - 1)) * globalWidth), ((- globalHeight) / 2)]);
  }
  letters.push(thisLetter);
  thisLetter = ["f", "F"];
  for (var Idx, _pj_c = 0, _pj_a = util.range(nY), _pj_b = _pj_a.length; (_pj_c < _pj_b); _pj_c += 1) {
      Idx = _pj_a[_pj_c];
      thisLetter.push([((- globalWidth) / 2), (((Idx - (nY / 2)) / nY) * globalHeight)]);
  }
  for (var Idx, _pj_c = 0, _pj_a = util.range(1, nY), _pj_b = _pj_a.length; (_pj_c < _pj_b); _pj_c += 1) {
      Idx = _pj_a[_pj_c];
      thisLetter.push([((((0.5 + Idx) - (nY / 2)) / (nY - 1)) * globalWidth), ((globalHeight / 2) - localHeight)]);
  }
  for (var Idx, _pj_c = 0, _pj_a = util.range(1, (nY - 2)), _pj_b = _pj_a.length; (_pj_c < _pj_b); _pj_c += 1) {
      Idx = _pj_a[_pj_c];
      thisLetter.push([((((0.5 + Idx) - (nY / 2)) / (nY - 1)) * globalWidth), ((- localHeight) / 2)]);
  }
  letters.push(thisLetter);
  thisLetter = ["n", "N"];
  for (var Idx, _pj_c = 0, _pj_a = util.range(nY), _pj_b = _pj_a.length; (_pj_c < _pj_b); _pj_c += 1) {
      Idx = _pj_a[_pj_c];
      thisLetter.push([((- globalWidth) / 2), (((Idx - (nY / 2)) / nY) * globalHeight)]);
  }
  for (var Idx, _pj_c = 0, _pj_a = util.range(1, (nY - 1)), _pj_b = _pj_a.length; (_pj_c < _pj_b); _pj_c += 1) {
      Idx = _pj_a[_pj_c];
      thisLetter.push([(((- ((0.5 + Idx) - (nY / 2))) / (nY - 1)) * globalWidth), (((Idx - (nY / 2)) / nY) * globalHeight)]);
  }
  for (var Idx, _pj_c = 0, _pj_a = util.range(nY), _pj_b = _pj_a.length; (_pj_c < _pj_b); _pj_c += 1) {
      Idx = _pj_a[_pj_c];
      thisLetter.push([(globalWidth / 2), (((Idx - (nY / 2)) / nY) * globalHeight)]);
  }
  letters.push(thisLetter);
  thisLetter = ["h", "H"];
  for (var Idx, _pj_c = 0, _pj_a = util.range(nY), _pj_b = _pj_a.length; (_pj_c < _pj_b); _pj_c += 1) {
      Idx = _pj_a[_pj_c];
      thisLetter.push([((- globalWidth) / 2), (((Idx - (nY / 2)) / nY) * globalHeight)]);
  }
  for (var Idx, _pj_c = 0, _pj_a = util.range(1, (nY - 1)), _pj_b = _pj_a.length; (_pj_c < _pj_b); _pj_c += 1) {
      Idx = _pj_a[_pj_c];
      thisLetter.push([((((0.5 + Idx) - (nY / 2)) / (nY - 1)) * globalWidth), ((- localHeight) / 2)]);
  }
  for (var Idx, _pj_c = 0, _pj_a = util.range(nY), _pj_b = _pj_a.length; (_pj_c < _pj_b); _pj_c += 1) {
      Idx = _pj_a[_pj_c];
      thisLetter.push([(globalWidth / 2), (((Idx - (nY / 2)) / nY) * globalHeight)]);
  }
  letters.push(thisLetter);
  thisLetter = ["t", "T"];
  for (var Idx, _pj_c = 0, _pj_a = util.range(nY), _pj_b = _pj_a.length; (_pj_c < _pj_b); _pj_c += 1) {
      Idx = _pj_a[_pj_c];
      thisLetter.push([((((0.5 + Idx) - (nY / 2)) / (nY - 1)) * globalWidth), ((globalHeight / 2) - localHeight)]);
  }
  for (var Idx, _pj_c = 0, _pj_a = util.range((nY - 1)), _pj_b = _pj_a.length; (_pj_c < _pj_b); _pj_c += 1) {
      Idx = _pj_a[_pj_c];
      thisLetter.push([0, (((Idx - (nY / 2)) / nY) * globalHeight)]);
  }
  letters.push(thisLetter);
  thisLetter = ["l", "L"];
  for (var Idx, _pj_c = 0, _pj_a = util.range(nY), _pj_b = _pj_a.length; (_pj_c < _pj_b); _pj_c += 1) {
      Idx = _pj_a[_pj_c];
      thisLetter.push([((- globalWidth) / 2), (((Idx - (nY / 2)) / nY) * globalHeight)]);
  }
  for (var Idx, _pj_c = 0, _pj_a = util.range(1, nY), _pj_b = _pj_a.length; (_pj_c < _pj_b); _pj_c += 1) {
      Idx = _pj_a[_pj_c];
      thisLetter.push([((((0.5 + Idx) - (nY / 2)) / (nY - 1)) * globalWidth), ((- globalHeight) / 2)]);
  }
  letters.push(thisLetter);
  thisLetter = ["v", "V"];
  for (var Idx, _pj_c = 0, _pj_a = util.range(0, nY), _pj_b = _pj_a.length; (_pj_c < _pj_b); _pj_c += 1) {
      Idx = _pj_a[_pj_c];
      thisLetter.push([(((((0.5 + Idx) - nY) / 2) / (nY - 1)) * globalWidth), (((Idx - (nY / 2)) / nY) * globalHeight)]);
  }
  for (var Idx, _pj_c = 0, _pj_a = util.range(0, nY), _pj_b = _pj_a.length; (_pj_c < _pj_b); _pj_c += 1) {
      Idx = _pj_a[_pj_c];
      thisLetter.push([((((- ((0.5 + Idx) - nY)) / 2) / (nY - 1)) * globalWidth), (((Idx - (nY / 2)) / nY) * globalHeight)]);
  }
  letters.push(thisLetter);
  thisLetter = ["x", "X"];
  for (var Idx, _pj_c = 0, _pj_a = util.range(0, nY), _pj_b = _pj_a.length; (_pj_c < _pj_b); _pj_c += 1) {
      Idx = _pj_a[_pj_c];
      thisLetter.push([(((- ((0.5 + Idx) - (nY / 2))) / (nY - 1)) * globalWidth), (((Idx - (nY / 2)) / nY) * globalHeight)]);
  }
  for (var Idx, _pj_c = 0, _pj_a = util.range(0, nY), _pj_b = _pj_a.length; (_pj_c < _pj_b); _pj_c += 1) {
      Idx = _pj_a[_pj_c];
      thisLetter.push([((((0.5 + Idx) - (nY / 2)) / (nY - 1)) * globalWidth), (((Idx - (nY / 2)) / nY) * globalHeight)]);
  }
  letters.push(thisLetter);
  thisLetter = ["o", "O"];
  for (var Idx, _pj_c = 0, _pj_a = util.range(0, nY), _pj_b = _pj_a.length; (_pj_c < _pj_b); _pj_c += 1) {
      Idx = _pj_a[_pj_c];
      thisLetter.push([(Math.sqrt((0.25 - Math.pow((((0.5 + Idx) - (nY / 2)) / (nY - 1)), 2))) * globalWidth), (((Idx - (nY / 2)) / nY) * globalHeight)]);
  }
  for (var Idx, _pj_c = 0, _pj_a = util.range((nY - 1)), _pj_b = _pj_a.length; (_pj_c < _pj_b); _pj_c += 1) {
      Idx = _pj_a[_pj_c];
      thisLetter.push([((- Math.sqrt((0.25 - Math.pow((((0.5 + Idx) - (nY / 2)) / (nY - 1)), 2)))) * globalWidth), (((Idx - (nY / 2)) / nY) * globalHeight)]);
  }
  Idx = 0.25;
  thisLetter.push([(Math.sqrt((0.25 - Math.pow((((0.5 + Idx) - (nY / 2)) / (nY - 1)), 2))) * globalWidth), (((Idx - (nY / 2)) / nY) * globalHeight)]);
  thisLetter.push([((- Math.sqrt((0.25 - Math.pow((((0.5 + Idx) - (nY / 2)) / (nY - 1)), 2)))) * globalWidth), (((Idx - (nY / 2)) / nY) * globalHeight)]);
  thisLetter.push([(Math.sqrt((0.25 - Math.pow((((0.5 + Idx) - (nY / 2)) / (nY - 1)), 2))) * globalWidth), (((- ((1 + Idx) - (nY / 2))) / nY) * globalHeight)]);
  thisLetter.push([((- Math.sqrt((0.25 - Math.pow((((0.5 + Idx) - (nY / 2)) / (nY - 1)), 2)))) * globalWidth), (((- ((1 + Idx) - (nY / 2))) / nY) * globalHeight)]);
  letters.push(thisLetter);
  elements = [];
  for (var Idx, _pj_c = 0, _pj_a = util.range(2, letters[0].length), _pj_b = _pj_a.length; (_pj_c < _pj_b); _pj_c += 1) {
      Idx = _pj_a[_pj_c];
      elements.push(new visual.TextStim({"win": psychoJS.window, "name": ("element" + Idx.toString()), "text": "N", "font": "Arial", "pos": letters[0][Idx], "height": localHeight, "wrapWidth": null, "ori": 0, "color": white}));
  }
  nReps = letters.length;
  console.log("nReps", nReps);
  
  // Initialize components for Routine "fix"
  fixClock = new util.Clock();
  polygon = new visual.Rect ({
    win: psychoJS.window, name: 'polygon', 
    width: [globalWidth, globalHeight][0], height: [globalWidth, globalHeight][1],
    ori: 0.0, pos: [0, ((- localHeight) / 2)],
    lineWidth: 1.0, lineColor: new util.Color('darkgrey'),
    fillColor: new util.Color('darkgrey'),
    opacity: undefined, depth: 0, interpolate: true,
  });
  
  // Initialize components for Routine "trial"
  trialClock = new util.Clock();
  key_resp = new core.Keyboard({psychoJS: psychoJS, clock: new util.Clock(), waitForStart: true});
  
  // Initialize components for Routine "feedback"
  feedbackClock = new util.Clock();
  text_thumb = new visual.TextStim({
    win: psychoJS.window,
    name: 'text_thumb',
    text: ' ',
    font: 'Wingdings',
    units: undefined, 
    pos: [0, 0], height: globalHeight,  wrapWidth: undefined, ori: 0.0,
    color: new util.Color('white'),  opacity: undefined,
    depth: -1.0 
  });
  
  // Initialize components for Routine "end"
  endClock = new util.Clock();
  text = new visual.TextStim({
    win: psychoJS.window,
    name: 'text',
    text: 'Fin',
    font: 'Open Sans',
    units: undefined, 
    pos: [0, 0], height: 0.1,  wrapWidth: undefined, ori: 0.0,
    color: new util.Color('white'),  opacity: undefined,
    depth: 0.0 
  });
  
  // Create some handy timers
  globalClock = new util.Clock();  // to track the time since experiment started
  routineTimer = new util.CountdownTimer();  // to track time remaining of each (non-slip) routine
  
  return Scheduler.Event.NEXT;
}


var t;
var frameN;
var continueRoutine;
var setupComponents;
function setupRoutineBegin(snapshot) {
  return async function () {
    TrialHandler.fromSnapshot(snapshot); // ensure that .thisN vals are up to date
    
    //------Prepare to start Routine 'setup'-------
    t = 0;
    setupClock.reset(); // clock
    frameN = -1;
    continueRoutine = true; // until we're told otherwise
    // update component parameters for each repeat
    // keep track of which components have finished
    setupComponents = [];
    
    setupComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
       });
    return Scheduler.Event.NEXT;
  }
}


function setupRoutineEachFrame() {
  return async function () {
    //------Loop for each frame of Routine 'setup'-------
    // get current time
    t = setupClock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    setupComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
      }
    });
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function setupRoutineEnd() {
  return async function () {
    //------Ending Routine 'setup'-------
    setupComponents.forEach( function(thisComponent) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    });
    // the Routine "setup" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    return Scheduler.Event.NEXT;
  };
}


var trials;
var currentLoop;
function trialsLoopBegin(trialsLoopScheduler, snapshot) {
  return async function() {
    TrialHandler.fromSnapshot(snapshot); // update internal variables (.thisN etc) of the loop
    
    // set up handler to look after randomisation of conditions etc
    trials = new TrialHandler({
      psychoJS: psychoJS,
      nReps: nReps, method: TrialHandler.Method.SEQUENTIAL,
      extraInfo: expInfo, originPath: undefined,
      trialList: undefined,
      seed: undefined, name: 'trials'
    });
    psychoJS.experiment.addLoop(trials); // add the loop to the experiment
    currentLoop = trials;  // we're now the current loop
    
    // Schedule all the trials in the trialList:
    trials.forEach(function() {
      const snapshot = trials.getSnapshot();
    
      trialsLoopScheduler.add(importConditions(snapshot));
      trialsLoopScheduler.add(fixRoutineBegin(snapshot));
      trialsLoopScheduler.add(fixRoutineEachFrame());
      trialsLoopScheduler.add(fixRoutineEnd());
      trialsLoopScheduler.add(trialRoutineBegin(snapshot));
      trialsLoopScheduler.add(trialRoutineEachFrame());
      trialsLoopScheduler.add(trialRoutineEnd());
      trialsLoopScheduler.add(feedbackRoutineBegin(snapshot));
      trialsLoopScheduler.add(feedbackRoutineEachFrame());
      trialsLoopScheduler.add(feedbackRoutineEnd());
      trialsLoopScheduler.add(endLoopIteration(trialsLoopScheduler, snapshot));
    });
    
    return Scheduler.Event.NEXT;
  }
}


async function trialsLoopEnd() {
  psychoJS.experiment.removeLoop(trials);

  return Scheduler.Event.NEXT;
}


var fixComponents;
function fixRoutineBegin(snapshot) {
  return async function () {
    TrialHandler.fromSnapshot(snapshot); // ensure that .thisN vals are up to date
    
    //------Prepare to start Routine 'fix'-------
    t = 0;
    fixClock.reset(); // clock
    frameN = -1;
    continueRoutine = true; // until we're told otherwise
    routineTimer.add(0.500000);
    // update component parameters for each repeat
    // keep track of which components have finished
    fixComponents = [];
    fixComponents.push(polygon);
    
    fixComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
       });
    return Scheduler.Event.NEXT;
  }
}


var frameRemains;
function fixRoutineEachFrame() {
  return async function () {
    //------Loop for each frame of Routine 'fix'-------
    // get current time
    t = fixClock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *polygon* updates
    if (t >= 0.0 && polygon.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      polygon.tStart = t;  // (not accounting for frame time here)
      polygon.frameNStart = frameN;  // exact frame index
      
      polygon.setAutoDraw(true);
    }

    frameRemains = 0.0 + 0.5 - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
    if (polygon.status === PsychoJS.Status.STARTED && t >= frameRemains) {
      polygon.setAutoDraw(false);
    }
    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    fixComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
      }
    });
    
    // refresh the screen if continuing
    if (continueRoutine && routineTimer.getTime() > 0) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function fixRoutineEnd() {
  return async function () {
    //------Ending Routine 'fix'-------
    fixComponents.forEach( function(thisComponent) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    });
    return Scheduler.Event.NEXT;
  };
}


var _key_resp_allKeys;
var trialComponents;
function trialRoutineBegin(snapshot) {
  return async function () {
    TrialHandler.fromSnapshot(snapshot); // ensure that .thisN vals are up to date
    
    //------Prepare to start Routine 'trial'-------
    t = 0;
    trialClock.reset(); // clock
    frameN = -1;
    continueRoutine = true; // until we're told otherwise
    // update component parameters for each repeat
    thisLetter = letters[trials.thisN];
    polygon.setAutoDraw(true);
    for (var Idx, _pj_c = 0, _pj_a = util.range((thisLetter.length - 2)), _pj_b = _pj_a.length; (_pj_c < _pj_b); _pj_c += 1) {
        Idx = _pj_a[_pj_c];
        elements[Idx].setPos(thisLetter[(Idx + 2)]);
        elements[Idx].text = thisLetter[1];
        elements[Idx].setAutoDraw(true);
    }
    
    key_resp.keys = undefined;
    key_resp.rt = undefined;
    _key_resp_allKeys = [];
    // keep track of which components have finished
    trialComponents = [];
    trialComponents.push(key_resp);
    
    trialComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
       });
    return Scheduler.Event.NEXT;
  }
}


function trialRoutineEachFrame() {
  return async function () {
    //------Loop for each frame of Routine 'trial'-------
    // get current time
    t = trialClock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *key_resp* updates
    if (t >= 0.0 && key_resp.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      key_resp.tStart = t;  // (not accounting for frame time here)
      key_resp.frameNStart = frameN;  // exact frame index
      
      // keyboard checking is just starting
      psychoJS.window.callOnFlip(function() { key_resp.clock.reset(); });  // t=0 on next screen flip
      psychoJS.window.callOnFlip(function() { key_resp.start(); }); // start on screen flip
      psychoJS.window.callOnFlip(function() { key_resp.clearEvents(); });
    }

    if (key_resp.status === PsychoJS.Status.STARTED) {
      let theseKeys = key_resp.getKeys({keyList: [], waitRelease: false});
      _key_resp_allKeys = _key_resp_allKeys.concat(theseKeys);
      if (_key_resp_allKeys.length > 0) {
        key_resp.keys = _key_resp_allKeys[_key_resp_allKeys.length - 1].name;  // just the last key pressed
        key_resp.rt = _key_resp_allKeys[_key_resp_allKeys.length - 1].rt;
        // was this correct?
        if (key_resp.keys == thisLetter[0]) {
            key_resp.corr = 1;
        } else {
            key_resp.corr = 0;
        }
        // a response ends the routine
        continueRoutine = false;
      }
    }
    
    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    trialComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
      }
    });
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function trialRoutineEnd() {
  return async function () {
    //------Ending Routine 'trial'-------
    trialComponents.forEach( function(thisComponent) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    });
    polygon.setAutoDraw(false);
    for (var Idx, _pj_c = 0, _pj_a = util.range((thisLetter.length - 2)), _pj_b = _pj_a.length; (_pj_c < _pj_b); _pj_c += 1) {
        Idx = _pj_a[_pj_c];
        elements[Idx].setAutoDraw(false);
    }
    
    // was no response the correct answer?!
    if (key_resp.keys === undefined) {
      if (['None','none',undefined].includes(thisLetter[0])) {
         key_resp.corr = 1;  // correct non-response
      } else {
         key_resp.corr = 0;  // failed to respond (incorrectly)
      }
    }
    // store data for psychoJS.experiment (ExperimentHandler)
    psychoJS.experiment.addData('key_resp.keys', key_resp.keys);
    psychoJS.experiment.addData('key_resp.corr', key_resp.corr);
    if (typeof key_resp.keys !== 'undefined') {  // we had a response
        psychoJS.experiment.addData('key_resp.rt', key_resp.rt);
        routineTimer.reset();
        }
    
    key_resp.stop();
    // the Routine "trial" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    return Scheduler.Event.NEXT;
  };
}


var feedbackComponents;
function feedbackRoutineBegin(snapshot) {
  return async function () {
    TrialHandler.fromSnapshot(snapshot); // ensure that .thisN vals are up to date
    
    //------Prepare to start Routine 'feedback'-------
    t = 0;
    feedbackClock.reset(); // clock
    frameN = -1;
    continueRoutine = true; // until we're told otherwise
    routineTimer.add(1.000000);
    // update component parameters for each repeat
    if (key_resp.corr) {
        text_thumb.text = "C";
    } else {
        text_thumb.text = "D";
    }
    
    // keep track of which components have finished
    feedbackComponents = [];
    feedbackComponents.push(text_thumb);
    
    feedbackComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
       });
    return Scheduler.Event.NEXT;
  }
}


function feedbackRoutineEachFrame() {
  return async function () {
    //------Loop for each frame of Routine 'feedback'-------
    // get current time
    t = feedbackClock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *text_thumb* updates
    if (t >= 0.0 && text_thumb.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      text_thumb.tStart = t;  // (not accounting for frame time here)
      text_thumb.frameNStart = frameN;  // exact frame index
      
      text_thumb.setAutoDraw(true);
    }

    frameRemains = 0.0 + 1 - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
    if (text_thumb.status === PsychoJS.Status.STARTED && t >= frameRemains) {
      text_thumb.setAutoDraw(false);
    }
    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    feedbackComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
      }
    });
    
    // refresh the screen if continuing
    if (continueRoutine && routineTimer.getTime() > 0) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function feedbackRoutineEnd() {
  return async function () {
    //------Ending Routine 'feedback'-------
    feedbackComponents.forEach( function(thisComponent) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    });
    return Scheduler.Event.NEXT;
  };
}


var endComponents;
function endRoutineBegin(snapshot) {
  return async function () {
    TrialHandler.fromSnapshot(snapshot); // ensure that .thisN vals are up to date
    
    //------Prepare to start Routine 'end'-------
    t = 0;
    endClock.reset(); // clock
    frameN = -1;
    continueRoutine = true; // until we're told otherwise
    // update component parameters for each repeat
    // keep track of which components have finished
    endComponents = [];
    endComponents.push(text);
    
    endComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
       });
    return Scheduler.Event.NEXT;
  }
}


function endRoutineEachFrame() {
  return async function () {
    //------Loop for each frame of Routine 'end'-------
    // get current time
    t = endClock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *text* updates
    if (t >= 0.0 && text.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      text.tStart = t;  // (not accounting for frame time here)
      text.frameNStart = frameN;  // exact frame index
      
      text.setAutoDraw(true);
    }

    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    endComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
      }
    });
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function endRoutineEnd() {
  return async function () {
    //------Ending Routine 'end'-------
    endComponents.forEach( function(thisComponent) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    });
    // the Routine "end" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    return Scheduler.Event.NEXT;
  };
}


function endLoopIteration(scheduler, snapshot) {
  // ------Prepare for next entry------
  return async function () {
    if (typeof snapshot !== 'undefined') {
      // ------Check if user ended loop early------
      if (snapshot.finished) {
        // Check for and save orphaned data
        if (psychoJS.experiment.isEntryEmpty()) {
          psychoJS.experiment.nextEntry(snapshot);
        }
        scheduler.stop();
      } else {
        const thisTrial = snapshot.getCurrentTrial();
        if (typeof thisTrial === 'undefined' || !('isTrials' in thisTrial) || thisTrial.isTrials) {
          psychoJS.experiment.nextEntry(snapshot);
        }
      }
    return Scheduler.Event.NEXT;
    }
  };
}


function importConditions(currentLoop) {
  return async function () {
    psychoJS.importAttributes(currentLoop.getCurrentTrial());
    return Scheduler.Event.NEXT;
    };
}


async function quitPsychoJS(message, isCompleted) {
  // Check for and save orphaned data
  if (psychoJS.experiment.isEntryEmpty()) {
    psychoJS.experiment.nextEntry();
  }
  
  
  
  
  
  
  
  
  psychoJS.window.close();
  psychoJS.quit({message: message, isCompleted: isCompleted});
  
  return Scheduler.Event.QUIT;
}
